# coding: utf-8

"""

    # Authentication  <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 0.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from apifff.api_client import ApiClient


class ClubApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def api_clubs_equipes_get_subresource_club_subresource(self, cl_no, **kwargs):  # noqa: E501
        """Retrieves a Club resource.  # noqa: E501

        Retrieves a Club resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_clubs_equipes_get_subresource_club_subresource(cl_no, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cl_no: Club identifier (required)
        :param int page: The collection page number
        :param int eq_no:
        :param list[int] eq_no:
        :return: InlineResponse2008
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_clubs_equipes_get_subresource_club_subresource_with_http_info(cl_no, **kwargs)  # noqa: E501
        else:
            (data) = self.api_clubs_equipes_get_subresource_club_subresource_with_http_info(cl_no, **kwargs)  # noqa: E501
            return data

    def api_clubs_equipes_get_subresource_club_subresource_with_http_info(self, cl_no, **kwargs):  # noqa: E501
        """Retrieves a Club resource.  # noqa: E501

        Retrieves a Club resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_clubs_equipes_get_subresource_club_subresource_with_http_info(cl_no, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cl_no: Club identifier (required)
        :param int page: The collection page number
        :param int eq_no:
        :param list[int] eq_no:
        :return: InlineResponse2008
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cl_no', 'page', 'eq_no', 'eq_no']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_clubs_equipes_get_subresource_club_subresource" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cl_no' is set
        if ('cl_no' not in params or
                params['cl_no'] is None):
            raise ValueError("Missing the required parameter `cl_no` when calling `api_clubs_equipes_get_subresource_club_subresource`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cl_no' in params:
            path_params['clNo'] = params['cl_no']  # noqa: E501

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'eq_no' in params:
            query_params.append(('eq_no', params['eq_no']))  # noqa: E501
        if 'eq_no' in params:
            query_params.append(('eq_no[]', params['eq_no']))  # noqa: E501
            collection_formats['eq_no[]'] = 'multi'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/ld+json', 'application/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/clubs/{clNo}/equipes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2008',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_club_collection(self, **kwargs):  # noqa: E501
        """Retrieves the collection of Club resources.  # noqa: E501

        Retrieves the collection of Club resources.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_club_collection(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int page: The collection page number
        :param str cl_cp:
        :param list[str] cl_cp:
        :param int cdg_cg_no:
        :param list[int] cdg_cg_no:
        :param int cl_cod:
        :param list[int] cl_cod:
        :param str cl_nom:
        :param str order_cl_cp:
        :return: InlineResponse2006
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_club_collection_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_club_collection_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_club_collection_with_http_info(self, **kwargs):  # noqa: E501
        """Retrieves the collection of Club resources.  # noqa: E501

        Retrieves the collection of Club resources.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_club_collection_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int page: The collection page number
        :param str cl_cp:
        :param list[str] cl_cp:
        :param int cdg_cg_no:
        :param list[int] cdg_cg_no:
        :param int cl_cod:
        :param list[int] cl_cod:
        :param str cl_nom:
        :param str order_cl_cp:
        :return: InlineResponse2006
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['page', 'cl_cp', 'cl_cp', 'cdg_cg_no', 'cdg_cg_no', 'cl_cod', 'cl_cod', 'cl_nom', 'order_cl_cp']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_club_collection" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'cl_cp' in params:
            query_params.append(('cl_cp', params['cl_cp']))  # noqa: E501
        if 'cl_cp' in params:
            query_params.append(('cl_cp[]', params['cl_cp']))  # noqa: E501
            collection_formats['cl_cp[]'] = 'multi'  # noqa: E501
        if 'cdg_cg_no' in params:
            query_params.append(('cdg.cg_no', params['cdg_cg_no']))  # noqa: E501
        if 'cdg_cg_no' in params:
            query_params.append(('cdg.cg_no[]', params['cdg_cg_no']))  # noqa: E501
            collection_formats['cdg.cg_no[]'] = 'multi'  # noqa: E501
        if 'cl_cod' in params:
            query_params.append(('cl_cod', params['cl_cod']))  # noqa: E501
        if 'cl_cod' in params:
            query_params.append(('cl_cod[]', params['cl_cod']))  # noqa: E501
            collection_formats['cl_cod[]'] = 'multi'  # noqa: E501
        if 'cl_nom' in params:
            query_params.append(('clNom', params['cl_nom']))  # noqa: E501
        if 'order_cl_cp' in params:
            query_params.append(('order[cl_cp]', params['order_cl_cp']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/ld+json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/clubs', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2006',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_club_item(self, cl_no, **kwargs):  # noqa: E501
        """Retrieves a Club resource.  # noqa: E501

        Retrieves a Club resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_club_item(cl_no, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cl_no: Resource identifier (required)
        :return: ClubJsonldClub
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_club_item_with_http_info(cl_no, **kwargs)  # noqa: E501
        else:
            (data) = self.get_club_item_with_http_info(cl_no, **kwargs)  # noqa: E501
            return data

    def get_club_item_with_http_info(self, cl_no, **kwargs):  # noqa: E501
        """Retrieves a Club resource.  # noqa: E501

        Retrieves a Club resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_club_item_with_http_info(cl_no, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cl_no: Resource identifier (required)
        :return: ClubJsonldClub
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cl_no']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_club_item" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cl_no' is set
        if ('cl_no' not in params or
                params['cl_no'] is None):
            raise ValueError("Missing the required parameter `cl_no` when calling `get_club_item`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cl_no' in params:
            path_params['clNo'] = params['cl_no']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/ld+json', 'application/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/clubs/{clNo}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClubJsonldClub',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
